//+------------------------------------------------------------------+
//|                                                          msr.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  50
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int MedianPeriod      = 10;
extern int MaxPeriod         = 20;
extern int PercentRankPeriod = 252;
extern int Price             = PRICE_TYPICAL;

//
//
//
//
//

double msr[];
double values[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,msr);
      SetIndexBuffer(1,values);
      SetIndexBuffer(2,prices);
   IndicatorShortName("msr");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

      double median = iQuantile(MedianPeriod,50.0,i);
      double max = prices[i];
         for (int k=1; k<MaxPeriod; k++)  max = MathMax(prices[i+k],max);

         values[i] = (median-max)/max;
         msr[i]    = percentRank(values,PercentRankPeriod,i);
   }
   return(0);      
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double percentRank(double& array[], double length, int i)
{
   double count = 0;
      for (int k=1; k<=length; k++) if (array[i]>=array[i+k]) count++;
   return(100.0*count/length);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double quantileArray[];
double iQuantile(int period, double qp, int i)
{
   if (ArraySize(quantileArray)!=period) ArrayResize(quantileArray,period);
                  for(int k=0; k<period && (i+k)<Bars; k++) quantileArray[k] = prices[i+k];
   ArraySort(quantileArray);

   //
   //
   //
   //
   //
   
   double index = (period-1)*qp/100.00;
   int    ind   = index;
   double delta = index - ind;
   if (ind == NormalizeDouble(index,5))
         return(            quantileArray[ind]);
   else  return((1.0-delta)*quantileArray[ind]+delta*quantileArray[ind+1]);
}